<?php
/**
 * The template for displaying Category pages
 *
 * @link http://codex.wordpress.org/Template_Hierarchy
 *
 * @package WordPress
 * @subpackage Twenty_Fourteen
 * @since Twenty Fourteen 1.0
 */


get_header(); ?>
<div id="content">
	<?php include (TEMPLATEPATH . '/sidebar-top.php'); ?>
	<div class="blog-wrapper">
		<div class="container">
			<div class="breadcrumbs">
				<ul>
				<li><a href="<?php echo site_url(); ?>">Home</a></li>
				<li>Blog</li>
				</ul>
			</div>
			<div class="blog-lft">
				<?php if ( have_posts() ) : ?>
				<div class="cat-title"><?php printf( __( 'Category Archives: %s', 'twentyfourteen' ), single_cat_title( '', false ) ); ?></div>
					<?php while ( have_posts() ) : the_post(); ?>
						<div class="blog-box" id="post-<?php the_ID(); ?>">
							<div class="blog-head"><a href="<?php the_permalink() ?>"><?php the_title( ); ?></a></div>
							<div class="post-line">Posted on <span class="p-date"><a href="<?php the_permalink() ?>"><?php the_date('M d, Y'); ?></a></span> by <span class="p-name"><a href="<?php echo get_author_posts_url( get_the_author_meta( 'ID' ), get_the_author_meta( 'user_nicename' ) ); ?>"><?php the_author_nickname(); ?></a></span>	</div>
							<?php $img= get_the_post_thumbnail($post_id, 'full'); 
							if($img != ""){ ?>
							<div class="center">
								<div class="post-photo">
									<a href="<?php the_permalink() ?>"><?php echo $img; ?></a>
								</div>
							</div>
							<?php } ?>
							<div class="post-sm-dis">
							<div class="post-lists"><?php the_excerpt(); ?></div>
							</div>
							<div class="r-more"><a href="<?php the_permalink() ?>">Read More</a></div>
							<div class="post-footer">
							<div class="post-ref">Posted on <?php the_category( ', ', $parents, $post_id ); ?></div>
							<div class="post-ref"><?php the_tags( 'Tagged  ' , ', ', '' ); ?></div>
							</div>
						</div>
					<?php endwhile; ?>
						<div class="pagination">
					 	<?php wp_paginate(); ?>
					 	</div>
					<?php else :
						get_template_part( 'content', 'none' );
					endif; ?>
			</div>
			<div class="blog-rgt">
				<?php get_sidebar(); ?>
			</div>
		</div>
	</div>
</div>
<?php get_footer(); ?>
