<?php

/**

 * The template for displaying the header

 *

 * Displays all of the head element and everything up until the "site-content" div.

 *

 * @package WordPress

 * @subpackage Twenty_Sixteen

 * @since Twenty Sixteen 1.0

 */



?><!DOCTYPE html>

<html <?php language_attributes(); ?> class="no-js">

<head>

	<meta charset="<?php bloginfo( 'charset' ); ?>">

	<meta name="viewport" content="user-scalable=no, width=device-width, initial-scale=1, maximum-scale=1.0">

	<link rel="profile" href="http://gmpg.org/xfn/11">

	<?php if ( is_singular() && pings_open( get_queried_object() ) ) : ?>

	<link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>">

	<?php endif; ?>

	<link rel="shortcut icon" href="<?php echo get_template_directory_uri(); ?>/images/favicon.ico" />

	<!--[if lt IE 9]>

	<script src="<?php echo get_template_directory_uri(); ?>/js/css3-mediaqueries.js"></script>

    <script type="text/javascript" src="<?php echo get_template_directory_uri(); ?>/js/html5shiv.js"></script>

	<![endif]-->

	<link href="<?php echo get_template_directory_uri(); ?>/css/style.css" rel="stylesheet" type="text/css" />

	<link href="<?php echo get_template_directory_uri(); ?>/style.css" rel="stylesheet" type="text/css" />

	<link href="<?php echo get_template_directory_uri(); ?>/css/mediaquery.css" rel="stylesheet" type="text/css" />

	

	<!--Mobile menu-->

	<link type="text/css" rel="stylesheet" href="<?php echo get_template_directory_uri(); ?>/css/jquery.mmenu.all.css" />

	<link href="<?php echo get_template_directory_uri(); ?>/css/jquery.mmenu.positioning.css" type="text/css" rel="stylesheet" />

	

	<!--Fonts-->

	<link href='https://fonts.googleapis.com/css?family=Raleway:400,700,800,300,500,600' rel='stylesheet' type='text/css'>

	<link href='https://fonts.googleapis.com/css?family=Ubuntu:400,300,500,700' rel='stylesheet' type='text/css'>

	

	<script type="text/javascript" src="<?php echo get_template_directory_uri(); ?>/js/jquery-1.11.3.min.js"></script>



<script type="text/javascript" src="<?php echo get_template_directory_uri(); ?>/js/jquery.ebcaptcha.js"></script>

	<!--Mobile-menu-->

<script type="text/javascript" src="<?php echo get_template_directory_uri(); ?>/js/jquery.mmenu.min.all.js"></script>



	<?php wp_head(); ?>

</head>



<body <?php body_class(); ?>>

<?php global $more; 

	global $shortnametheme;

	$shortnametheme = "tms";

?>

<nav id="menu">

<ul>

<li><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/index.php" class="home">Home</a></li>

<li><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/website-designers-colorado-seo-website-design-website-development-co.php" class="web">Web Design</a></li>

<li><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/pay-per-click-PPC-colorado-ppc-consultants-paid-search-marketing-co.php" class="ppc">Adwords (PPC)</a></li>

<li><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/search-engine-optimization-colorado-seo-consultants-co.php" class="seo">SEO</a></li>

<li><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/video-production-services-colorado-internet-videos-co.php" class="video">Video Production</a></li>

<li><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/ecommerce-website-design-denver-co-magento-woocommerce-web-designers-colorado.php" class="ec">E-Commerce</a>

<ul>

    <li class="mag"><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/magento-developers-ecommerce-store-programmers-website-designers.php" class="ec">Magento</a></li>

    <li class="woo"><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/woocommerce-developers-ecommerce-store-programmers-website-designers.php" class="ec">Woocommerce</a></li>

        <!--<li class="sho"><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/shopify.php" class="ec">Shopify</a></li>-->

    <li class="big"><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/bigcommerce-developers-ecommerce-store-programmers-website-designers.php" class="ec">BigCommerce</a></li>

</ul>

</li>

<li><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/seo-ppc-website-design-client-testimonials.php" class="test">Testimonials</a></li>

<li><a href="<?php echo site_url(); ?>" class="blog active">Blog</a></li>

<li><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/about-us-internet-marketing-services-company.php" class="about">About</a></li>

<li><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/contact-website-design-seo-ppc-internet-marketing-services-company.php" class="contact">Contact</a></li>

</ul>

</nav>

<div id="wrapper">

<header id="header">

<div class="container">

<div class="logo"><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>"><img src="<?php echo get_template_directory_uri(); ?>/images/TMS-logo.png" alt="Target Marketing Solution"></a></div>

<div class="header-rgt">



<div class="hd-tp-line">

<div class="tag-line"><?php echo stripslashes(get_option($shortnametheme."_head_slogan")); ?></div>

<div class="mb-menu-area">

<a href="#menu" class="menu-trigger">Menu</a>

</div>

<?php

$search = array( '(', ')', '-', ' ' );

$replace = array('', '', '','');

?>

<div class="mb-call"><a href="javascript:;">contact us</a></div>

<div class="call-txt">Call Toll Free: <strong><?php echo stripslashes(get_option($shortnametheme."_head_phn")); ?></strong></div>

<div class="call-txt-tab"><a href="tel:+1<?php echo str_replace($search,$replace,(get_option($shortnametheme."_head_phn"))); ?>">Click-to-call <?php echo stripslashes(get_option($shortnametheme."_head_phn")); ?></a></div>

<div class="call-txt-mb"><a href="tel:+18882390332">Click-to-call</a></div>





</div>

<div class="menu">

<ul>

<li><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/website-designers-colorado-seo-website-design-website-development-co.php" class="web">Web Design</a></li>

<li><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/pay-per-click-PPC-colorado-ppc-consultants-paid-search-marketing-co.php" class="ppc">Adwords (PPC)</a></li>

<li><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/search-engine-optimization-colorado-seo-consultants-co.php" class="seo">SEO</a></li>

<li><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/video-production-services-colorado-internet-videos-co.php" class="video">Video Production</a></li>

<li><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/ecommerce-website-design-denver-co-magento-woocommerce-web-designers-colorado.php" class="ec">E-Commerce</a>

<ul>

	<li class="mag"><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/magento-developers-ecommerce-store-programmers-website-designers.php" class="ec">Magento</a></li>

	<li class="woo"><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/woocommerce-developers-ecommerce-store-programmers-website-designers.php" class="ec">Woocommerce</a></li>

	    <!--<li class="sho"><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/shopify.php" class="ec">Shopify</a></li>-->

	<li class="big"><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/bigcommerce-developers-ecommerce-store-programmers-website-designers.php" class="ec">BigCommerce</a></li>

</ul>

</li>

<li><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/website-design-portfolio-business-commercial-corporate-industrial-website-examples-samples.php" class="test">Portfolio</a></li>

<li><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/seo-ppc-website-design-client-testimonials.php" class="test">Testimonials</a></li>

<li><a href="<?php echo site_url(); ?>" class="blog active">Blog</a></li>

<li><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/about-us-internet-marketing-services-company.php" class="about">About</a></li>

<li><a href="<?php echo stripslashes(get_option($shortnametheme."_site_url")); ?>/contact-website-design-seo-ppc-internet-marketing-services-company.php" class="contact">Contact</a></li>

</ul>

</div>

</div>

</div>

</header>