<?php
/**
 * The template for displaying all single posts and attachments
 *
 * @package WordPress
 * @subpackage Twenty_Sixteen
 * @since Twenty Sixteen 1.0
 */

get_header(); ?>

<div id="content">
	<?php include (TEMPLATEPATH . '/sidebar-top.php'); ?>
	<div class="blog-wrapper">
		<div class="container">
			<div class="breadcrumbs">
			<ul>
			<li><a href="<?php echo site_url(); ?>">Home</a></li>
			<li>Blog</li>
			</ul>
			</div>
			<div class="blog-lft">
				<?php while ( have_posts() ) : the_post(); ?>
					<div class="blog-box nobor" id="post-<?php the_ID(); ?>">
						<div class="blog-head"><?php the_title( ); ?></div>
						<div class="post-line">Posted on <span class="p-date"><a href="<?php the_permalink() ?>"><?php the_date('M d, Y'); ?></a></span> by <span class="p-name"><a href="<?php echo get_author_posts_url( get_the_author_meta( 'ID' ), get_the_author_meta( 'user_nicename' ) ); ?>"><?php the_author_nickname(); ?></a></span>	</div>
						<?php $img= get_the_post_thumbnail($post_id, 'full'); 
						if($img != ""){ ?>
						<div class="center">
							<div class="post-photo">
								<a href="<?php the_permalink() ?>"><?php echo $img; ?></a>
							</div>
						</div>
						<?php } ?>
						<div class="post-sm-dis">
						<p class="nopad"><?php the_content(); ?></p>
						</div>
						<div class="post-footer">
						<div class="post-ref">Posted on <?php the_category( ', ', $parents, $post_id ); ?></div>
						<div class="post-ref"><?php the_tags( 'Tagged  ' , ', ', '' ); ?></div>
						</div>
					</div>
					<div class="blog-form">
						<?php 
						if ( comments_open() || get_comments_number() ) {
						comments_template();
						} else {?><p class="no-comments"><?php  echo "Comments are closed.";?></p><?php }?>
					</div>
					<div class="in-pagi">
					<ul>
					<li><?php previous_post('%', 'Previous Post', 'no'); ?></li>
					<li><?php next_post('%', 'Next Post', 'no'); ?></li>
					</ul>
					</div>
				<?php endwhile; ?>
			</div>
			<div class="blog-rgt">
			<?php get_sidebar(); ?>
			</div>
		</div>
	</div>
</div>
<?php get_footer(); ?>
